/**********************************************
miniPlayer

Design & Code: Jorge Vilas
Copyright (C) 2006 Jorge Vilas. All Rights Reserved.

Version History:
1.0 (May 2006) - Initial Release
1.1 (May 2006)	- Added ability to open and close the player
1.2 (May 2006)	- Added ability play files in subdirectories
                        - Added 8 different skins
1.3 (May 2006)	- Save last used folder in preferences
								- Ignore non playable files in folder
								- Display song title when playing Audio CD
								- Scroll title when text is too big to fit into display
								- New skins
1.4 (June 2006)	-	Hoykeys added
***********************************************/

var Player = COM.createObject("wmplayer.ocx");
var Playlist, IsPlaylist, PlayIndex;
COM.connectObject(Player, "WMP_");
Player.settings.setMode("loop", false);
Player.settings.autoStart = false;
var CDROM = Player.cdromCollection;
fileInfo = new Object();
var playerStatus = "OFF";
var slidePlayer = "closed";
var Status = "stopped";
var isAudioCD = false;
var skin = preferences.Skin.value.replace(/ /g,"_");

var sourceMenu = new Array();
sourceMenu.push(new MenuItem());
sourceMenu[0].title = "Last used folder";
sourceMenu[0].onSelect = "PlayFolder(preferences.musicFolder.value);";
sourceMenu[0].enabled = true;
sourceMenu.push(new MenuItem());
sourceMenu[1].title = "Select a File...";
sourceMenu[1].onSelect = "PlayFile(chooseFile())";
sourceMenu[1].enabled = true;
sourceMenu.push(new MenuItem());
sourceMenu[2].title = "Select a Folder...";
sourceMenu[2].onSelect = "PlayFolder(chooseFolder());";
sourceMenu[2].enabled = true;
for(var i = 0; i < CDROM.count; i++) {
	var m = new MenuItem();
	m.title = "Audio CD Drive ("+ CDROM.Item(i).driveSpecifier +")";
	m.onSelect = "PlayAudioCD(" + i + ", CDROM.Item("+ i +").Playlist)"
	m.enabled = true;
	sourceMenu.push(m);
}

function init() {
	soundValue = preferences.volume.value;
	setSkin();
	volumeScale();
}

function setSkin() {
	bodyLeft.src = "Resources/Skins/" + skin + "/bodyLeft.png";
	background.src = "Resources/Skins/" + skin + "/bodyBg.png";
	bodyRight.src = "Resources/Skins/" + skin + "/bodyRight.png";
	btnOnOff.visible = true;
}

function doSlide() {
	suppressUpdates();
	if (slidePlayer == "open") {
		background.slide("left",0, 1);
		background.visible = false;
		bodyRight.visible = true;
		deactivate();
		slidePlayer = "closed";
		mainWindow.width = 37;
	} else {
		mainWindow.width = 222;
		bodyRight.visible = false;
		background.visible = true;
		background.slide("right", 0, 1);
		activate();
		slidePlayer = "open";
	}
	resumeUpdates();
}

function activate() {
	Track.data = "SELECT SOURCE";
	volumeLabel.data = "VOLUME";
	volumeLabel.onMouseUp = "mute();";
	volumeScale();
	for (c = 1; c < 11; c++) {
		volumePos[c].visible = true;
	}
	volumeValue.data = soundValue + "%";
	btnOnOff.src = "Resources/Images/btnOn.png";
	btnOnOff.onMouseEnter = "btnOnOff.src = 'Resources/Images/btnOff.png'";
	btnOnOff.onMouseExit = "btnOnOff.src = 'Resources/Images/btnOn.png'";
	btnOnOff.tooltip = "Close miniPlayer";
	btnSource.src = "Resources/Images/btnSource.png";
	btnSource.onMouseEnter = "btnSource.src = 'Resources/Images/btnSourceOver.png'";
	btnSource.onMouseExit = "btnSource.src = 'Resources/Images/btnSource.png'";
	btnSource.onMouseUp = "popupMenu(sourceMenu, system.event.hOffset, system.event.vOffset+7);";
	btnPlay.visible = true;
	btnPause.visible = true;
	btnStop.visible = true;
	btnPrev.visible = true;
	btnNext.visible = true;
	btnShuffle.visible = true;
	btnSource.visible = true;
	changeCtrlPanelState("standby");
}

function deactivate() {
	if(Status == "playing") {
		stopSong();
		delete Playlist;
	}
	Track.data = "";
	Position.data = "";
	Duration.data = "";
	volumeLabel.data = "";
	volumeLabel.onMouseUp = "";
	for (c = 1; c < 11; c++) {
		volumePos[c].visible = false;
		volumePos[c].tooltip = "";
		volumePos[c].onMouseUp = "";
	}
	volumeValue.data = "";
	btnOnOff.src = "Resources/Images/btnOff.png";
	btnOnOff.onMouseEnter = "btnOnOff.src = 'Resources/Images/btnOn.png'";
	btnOnOff.onMouseExit = "btnOnOff.src = 'Resources/Images/btnOff.png'";
	btnOnOff.tooltip = "Open miniPlayer";
	btnSource.src = "Resources/Images/btnSourceNull.png";
	btnPlay.visible =  false;
	btnPause.visible =  false;
	btnStop.visible =  false;
	btnPrev.visible =  false;
	btnNext.visible =  false;
	btnShuffle.visible =  false;
	btnSource.visible =  false;
}

function volumeScale() {
	volumePos = new Array();
	var n = 147;
	for (c = 1; c < 11; c++) {
		volumePos[c] = new Image();
		volumePos[c].window = mainWindow;
		if (c * 10 <= preferences.volume.value) {
			volumePos[c].src = "Resources/Images/scaleBar1.png";
		} else {
			volumePos[c].src = "Resources/Images/scaleBar0.png";
		}
		volumePos[c].width = 3;
		volumePos[c].height = 7;
		volumePos[c].hOffset = n;
		volumePos[c].vOffset = 10;
		volumePos[c].visible = false;
		vLevel = c * 10;
		volumePos[c].tooltip = "Volume= " + vLevel + "%";
		volumePos[c].onMouseUp = "soundCtrl(" + vLevel + ");";
		n = n + 3;
	}
}

function soundCtrl(vl) {
	setSound(vl);
	soundValue = vl;
}

function setSound(value) {
	Player.settings.volume = value;
	if (slidePlayer == "open") {
		volumeValue.data = Player.settings.volume + "%";
	}
	preferences.volume.value = Player.settings.volume;
	var n = 134;
	for (c = 1; c < 11; c++) {
		if (c * 10 <= value) {
			volumePos[c].src = "Resources/Images/scaleBar1.png";
		} else {
			volumePos[c].src = "Resources/Images/scaleBar0.png";
		}
	}
}

function mute() {
	if (Player.settings.mute) {
		Player.settings.mute = false;
		volumeLabel.tooltip = "Mute";
	} else {
		Player.settings.mute = true;
		volumeLabel.tooltip = "Unmute";
	}
}

function WMP_PlayStateChange(state) {
	if(state == 8) {
		// stopped
		Timer1.ticking = false;
		if(IsPlaylist || ((PlayIndex + 1) >= Playlist.length)) {
			PlayIndex = 0;
			Player.URL = null;
			Position.data ="";
			Duration.data = "";
			Track.data = "SELECT SOURCE";
			changeCtrlPanelState("standby")
		} else {
			Timer2.ticking = true;
		}
	} else if(state == 10) {
		// ready
		Timer1.ticking = true;
	}
	else if(state == 3) {
		// playing
		Duration.data = "OF "+ Player.currentMedia.durationString;
		if (! isAudioCD) {
			Track.data = Player.currentMedia.name.toUpperCase();
		}
		navPlayList();
	}
}

function FileMedia(path) {
	this.sourceURL = path;
}

function PlayFile(fn) {
	isAudioCD = false;
	if(fn.length > 4) {
		var ext = fn.substr(fn.length - 3).toLowerCase();
		IsPlaylist = (ext == "m3u") || (ext == "wpl") || (ext == "wax");
	} else {
		IsPlaylist = false;
	}
	if(IsPlaylist) {
		Player.URL = fn;
		Player.controls.play();
		PlayIndex = 0;
	} else {
		Playlist = new Array(1);
		Playlist[0] = new FileMedia(fn);
		PlayMedia(0);
	}
	changeCtrlPanelState("playing")
	btnShuffle.src = "Resources/Images/btnShuffleNull.png";
	btnShuffle.onMouseEnter = "btnShuffle.src = 'Resources/Images/btnShuffleNull.png'";
	btnShuffle.onMouseExit = "btnShuffle.src = 'Resources/Images/btnShuffleNull.png'";
	btnShuffle.onMouseUp = "";
}

function PlayFolder(path) {
	isAudioCD = false;
	IsPlaylist = false;
	var fs = filesystem.getDirectoryContents(path, true);
	tmpList = new Array(fs.length);
	dirList = new Array(fs.length);
	var idxFile = 0;
	var idxFolder = 0;
	for(var i = 0; i < fs.length; i++) {
		if (! filesystem.isDirectory(path + "\\" + fs[i])) {
			for (n = fs[i].length; n > 0; n--) {
				if(fs[i].substring(n-1,n) == ".") {
					var idxExt = n;
					break;
				}
			}
			var ext = fs[i].substring(idxExt, fs[i].length).toLowerCase();
			if (ext == "mp3" || ext == "wav" || ext == "wma" || ext == "aif" || ext == "aiff" || ext == "au" || ext == "snd") {
				IsSong = true;
			} else {
				IsSong = false;
			}
			if (IsSong) {
				tmpList[idxFile] = new FileMedia(path + "\\" + fs[i]);
				idxFile++;
			}
		} else {
			dirList[idxFolder] = new FileMedia(path + "\\" + fs[i]);
			idxFolder++;
		}
	}
	if (idxFile > 0) {
		Playlist = new Array(idxFile);
		for(var i = 0; i < idxFile; i++) {
			Playlist[i] = tmpList[i];
		}
		btnShuffle.src = "Resources/Images/btnShuffle.png";
		btnShuffle.onMouseEnter = "btnShuffle.src = 'Resources/Images/btnShuffleOver.png'";
		btnShuffle.onMouseExit = "btnShuffle.src = 'Resources/Images/btnShuffle.png'";
		btnShuffle.onMouseUp = "shuffle (Playlist);";
		saveDirectory(path);
		changeCtrlPanelState("playing");
		PlayMedia(0);
	}
}

function saveDirectory(folderPath){
	if (folderPath != preferences.musicFolder.value) {
		if (folderPath != "") {
			folderPath = folderPath + "\\";
		}
		preferences.musicFolder.value = folderPath;
	} else{
		return;
	}
}

function PlayAudioCD(cdDriver, pList) {
	isAudioCD = true;
	IsPlaylist = false;
	IsPlaylist = false;
	oCDROM = CDROM.Item(cdDriver);
	colPlaylist = oCDROM.Playlist;
	Playlist = new Array(pList.count);
	cdPlaylistTitles = new Array(pList.count);
	for(var i = 0; i < pList.count; i++) {
		Playlist[i] = pList.Item(i);
		objSong = colPlaylist.Item(i);
		cdPlaylistTitles[i] = objSong.getItemInfo("title");
	}
	changeCtrlPanelState("playing");
	PlayMedia(0);
	btnShuffle.src = "Resources/Images/btnShuffle.png";
	btnShuffle.onMouseEnter = "btnShuffle.src = 'Resources/Images/btnShuffleOver.png'";
	btnShuffle.onMouseExit = "btnShuffle.src = 'Resources/Images/btnShuffle.png'";
	btnShuffle.onMouseUp = "shuffle (Playlist);";
}

function PlayMedia(i) {
	if (isAudioCD) {
		Track.data = cdPlaylistTitles[i].toUpperCase();
	}
	PlayIndex = i;
	Player.URL = Playlist[i].sourceURL;
	Player.controls.play();
}

function playSong() {
	if(Status != "playing") {
		Player.controls.play();
		Timer1.ticking = true;
		changeCtrlPanelState("playing")
	}
}

function pauseSong() {
	if(Status == "playing") {
		Player.controls.pause();
		Timer1.ticking = false;
		changeCtrlPanelState("paused")
	}
}

function stopSong() {
	if(Status == "playing") {
		Player.controls.stop();
		Timer1.ticking = false;
		Position.data ="00:00";
		changeCtrlPanelState("stopped")
	}
}

function getPreviousSong() {
	if(btnPrev.src != "Resources/Images/btnPrevNull.png") {
		if(IsPlaylist) {
			PlayIndex--;
			Player.controls.previous();
		} else {
			PlayMedia(PlayIndex - 1);
		}
		changeCtrlPanelState("playing")
	}
}

function getNextSong() {
	if(btnNext.src != "Resources/Images/btnNextNull.png") {
		if(IsPlaylist) {
			PlayIndex++;
			Player.controls.next();
		} else {
			PlayMedia(PlayIndex + 1);
		}
		changeCtrlPanelState("playing")
	}
}

function shuffle(Playlist) {
  var i = Playlist.length;
  if (i == 0) return false;
  while (--i) {
     var j = Math.floor( Math.random() * (i + 1));
     var tempi = Playlist[i];
     var tempj = Playlist[j];
     Playlist[i] = tempj;
     Playlist[j] = tempi;
		if (isAudioCD) {
			var objSongi = cdPlaylistTitles[i];
			var objSongj = cdPlaylistTitles[j];
			cdPlaylistTitles[i] = objSongj;
			cdPlaylistTitles[j] = objSongi;
		}
   }
	changeCtrlPanelState("playing")
	PlayMedia(0);
}

function hotkeyEvent(keyEvent) {
		switch (keyEvent) {
			case "hkey1":
				filesystem.open('Resources/help.html');
				break;

			case "hkey2":
				getPreviousSong();
				break;

			case "hkey3":
				if (Status == "paused" || Status == "stopped") playSong();
				break;

			case "hkey4":
				if (Status == "playing") pauseSong();
				break;

			case "hkey5":
				if (Status == "playing") stopSong();
				break;

			case "hkey6":
				getNextSong();
				break;

			case "hkey7":
				if(slidePlayer == "open") popupMenu(sourceMenu, system.event.hOffset, system.event.vOffset+7);
				break;

			case "hkey8":
					mute();
				break;

			case "hkey9":
				doSlide();
				break;

			default: break;
		}
}

function navPlayList() {
	if (PlayIndex == 0) {
		btnPrev.src = "Resources/Images/btnPrevNull.png";
		btnPrev.onMouseEnter = "btnPrev.src = 'Resources/Images/btnPrevNull.png'";
		btnPrev.onMouseExit = "btnPrev.src = 'Resources/Images/btnPrevNull.png'";
		btnPrev.onMouseUp = "";
	} else {
		btnPrev.src = "Resources/Images/btnPrev.png";
		btnPrev.onMouseEnter = "btnPrev.src = 'Resources/Images/btnPrevOver.png'";
		btnPrev.onMouseExit = "btnPrev.src = 'Resources/Images/btnPrev.png'";
		btnPrev.onMouseUp = "getPreviousSong();";
	}
	if(IsPlaylist) {
		if ((PlayIndex + 1) >= Player.currentPlaylist.count) {
			btnNext.src = "Resources/Images/btnNextNull.png";
			btnNext.onMouseEnter = "btnNext.src = 'Resources/Images/btnNextNull.png'";
			btnNext.onMouseExit = "btnNext.src = 'Resources/Images/btnNextNull.png'";
			btnNext.onMouseUp = "";
		} else {
			btnNext.src = "Resources/Images/btnNext.png";
			btnNext.onMouseEnter = "btnNext.src = 'Resources/Images/btnNextOver.png'";
			btnNext.onMouseExit = "btnNext.src = 'Resources/Images/btnNext.png'";
			btnNext.onMouseUp = "getNextSong();";
		}
	} else {
		if ((PlayIndex + 1) >= Playlist.length) {
			btnNext.src = "Resources/Images/btnNextNull.png";
			btnNext.onMouseEnter = "btnNext.src = 'Resources/Images/btnNextNull.png'";
			btnNext.onMouseExit = "btnNext.src = 'Resources/Images/btnNextNull.png'";
			btnNext.onMouseUp = "";
		} else {
			btnNext.src = "Resources/Images/btnNext.png";
			btnNext.onMouseEnter = "btnNext.src = 'Resources/Images/btnNextOver.png'";
			btnNext.onMouseExit = "btnNext.src = 'Resources/Images/btnNext.png'";
			btnNext.onMouseUp = "getNextSong();";
		}
	}
}

function changeCtrlPanelState(newState) {
	switch (newState) {

		case "playing":
			Status= "playing";
			btnPlay.src = "Resources/Images/btnPlayNull.png";
			btnPlay.onMouseEnter = "btnPlay.src = 'Resources/Images/btnPlayNull.png'";
			btnPlay.onMouseExit = "btnPlay.src = 'Resources/Images/btnPlayNull.png'";
			btnPlay.onMouseUp = "";
			btnPause.src = "Resources/Images/btnPause.png";
			btnPause.onMouseEnter = "btnPause.src = 'Resources/Images/btnPauseOver.png'";
			btnPause.onMouseExit = "btnPause.src = 'Resources/Images/btnPause.png'";
			btnPause.onMouseUp = "pauseSong();";
			btnStop.src = "Resources/Images/btnStop.png";
			btnStop.onMouseEnter = "btnStop.src = 'Resources/Images/btnStopOver.png'";
			btnStop.onMouseExit = "btnStop.src = 'Resources/Images/btnStop.png'";
			btnStop.onMouseUp = "stopSong();";
			navPlayList();
			break;

		case "paused":
			Status= "paused";
			btnPlay.src = "Resources/Images/btnPlay.png";
			btnPlay.onMouseEnter = "btnPlay.src = 'Resources/Images/btnPlayOver.png'";
			btnPlay.onMouseExit = "btnPlay.src = 'Resources/Images/btnPlay.png'";
			btnPlay.onMouseUp = "playSong();";
			btnPause.src = "Resources/Images/btnPauseNull.png";
			btnPause.onMouseEnter = "btnPause.src = 'Resources/Images/btnPauseNull.png'";
			btnPause.onMouseExit = "btnPause.src = 'Resources/Images/btnPauseNull.png'";
			btnPause.onMouseUp = "";
			btnStop.src = "Resources/Images/btnStopNull.png";
			btnStop.onMouseEnter = "btnStop.src = 'Resources/Images/btnStopNull.png'";
			btnStop.onMouseExit = "btnStop.src = 'Resources/Images/btnStopNull.png'";
			btnStop.onMouseUp = "";
			navPlayList();
			break;

		case "stopped":
			Status= "stopped";
			btnPlay.src = "Resources/Images/btnPlay.png";
			btnPlay.onMouseEnter = "btnPlay.src = 'Resources/Images/btnPlayOver.png'";
			btnPlay.onMouseExit = "btnPlay.src = 'Resources/Images/btnPlay.png'";
			btnPlay.onMouseUp = "playSong();";
			btnPause.src = "Resources/Images/btnPauseNull.png";
			btnPause.onMouseEnter = "btnPause.src = 'Resources/Images/btnPauseNull.png'";
			btnPause.onMouseExit = "btnPause.src = 'Resources/Images/btnPauseNull.png'";
			btnPause.onMouseUp = "";
			btnStop.src = "Resources/Images/btnStopNull.png";
			btnStop.onMouseEnter = "btnStop.src = 'Resources/Images/btnStopNull.png'";
			btnStop.onMouseExit = "btnStop.src = 'Resources/Images/btnStopNull.png'";
			btnStop.onMouseUp = "";
			navPlayList();
			break;

		case "standby":
			btnPlay.src = "Resources/Images/btnPlayNull.png";
			btnPlay.onMouseExit = "btnPlay.src = 'Resources/Images/btnPlayNull.png'";
			btnPlay.onMouseEnter = "btnPlay.src = 'Resources/Images/btnPlayNull.png'";
			btnPlay.onMouseUp = "";
			btnPause.src = "Resources/Images/btnPauseNull.png";
			btnPause.onMouseEnter = "btnPause.src = 'Resources/Images/btnPauseNull.png'";
			btnPause.onMouseExit = "btnPause.src = 'Resources/Images/btnPauseNull.png'";
			btnPause.onMouseUp = "";
			btnStop.src = "Resources/Images/btnStopNull.png";
			btnStop.onMouseEnter = "btnStop.src = 'Resources/Images/btnStopNull.png'";
			btnStop.onMouseExit = "btnStop.src = 'Resources/Images/btnStopNull.png'";
			btnStop.onMouseUp = "";
			btnPrev.src = "Resources/Images/btnPrevNull.png";
			btnPrev.onMouseUp = "";
			btnPrev.onMouseEnter = "btnPrev.src = 'Resources/Images/btnPrevNull.png'";
			btnPrev.onMouseExit = "btnPrev.src = 'Resources/Images/btnPrevNull.png'";
			btnNext.src = "Resources/Images/btnNextNull.png";
			btnNext.onMouseEnter = "btnNext.src = 'Resources/Images/btnNextNull.png'";
			btnNext.onMouseExit = "btnNext.src = 'Resources/Images/btnNextNull.png'";
			btnNext.onMouseUp = "";
			btnShuffle.src = "Resources/Images/btnShuffleNull.png";
			btnShuffle.onMouseEnter = "btnShuffle.src = 'Resources/Images/btnShuffleNull.png'";
			btnShuffle.onMouseExit = "btnShuffle.src = 'Resources/Images/btnShuffleNull.png'";
			btnShuffle.onMouseUp = "";
			break;

		default:
			break;
	}
}